


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: UserService</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.service</a> ]
</div>

<h1>Coverage Summary for Class: UserService (com.dema.timeregistration.service)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">UserService</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    60%
  </span>
  <span class="absValue">
    (3/ 5)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    66.7%
  </span>
  <span class="absValue">
    (10/ 15)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.service;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import com.dema.timeregistration.entity.GlobalRole;
<i>4</i>&nbsp;import com.dema.timeregistration.entity.User;
<i>5</i>&nbsp;import com.dema.timeregistration.repository.UserRepository;
<i>6</i>&nbsp;import com.dema.timeregistration.service.exception.EntityAlreadyExistsException;
<i>7</i>&nbsp;import com.dema.timeregistration.service.exception.EntityNotFoundException;
<i>8</i>&nbsp;
<i>9</i>&nbsp;import java.time.Instant;
<i>10</i>&nbsp;import java.util.stream.Collectors;
<i>11</i>&nbsp;
<i>12</i>&nbsp;public class UserService {
<i>13</i>&nbsp;    private final UserRepository userRepository;
<i>14</i>&nbsp;
<b class="fc"><i>15</i>&nbsp;    public UserService(UserRepository userRepository) {</b>
<b class="fc"><i>16</i>&nbsp;        this.userRepository = userRepository;</b>
<b class="fc"><i>17</i>&nbsp;    }</b>
<i>18</i>&nbsp;
<i>19</i>&nbsp;    public void register(String email, String name) throws EntityAlreadyExistsException {
<b class="fc"><i>20</i>&nbsp;        if (userRepository.existsByEmail(email)) {</b>
<b class="fc"><i>21</i>&nbsp;            throw new EntityAlreadyExistsException(&quot;The email &quot; + email + &quot; is already taken&quot;);</b>
<i>22</i>&nbsp;        }
<i>23</i>&nbsp;
<b class="fc"><i>24</i>&nbsp;        User user = User.create(email, name, GlobalRole.GLOBAL_USER);</b>
<b class="fc"><i>25</i>&nbsp;        userRepository.save(user);</b>
<b class="fc"><i>26</i>&nbsp;    }</b>
<i>27</i>&nbsp;
<i>28</i>&nbsp;    public UserContext login(String email) throws EntityNotFoundException {
<b class="fc"><i>29</i>&nbsp;        User user = userRepository.findByEmail(email).orElseThrow(() -&gt; new EntityNotFoundException(&quot;A user with the email &#39;&quot; + email + &quot;&#39; could not be found&quot;));</b>
<b class="fc"><i>30</i>&nbsp;        return new UserContext(Instant.now(), user);</b>
<i>31</i>&nbsp;    }
<i>32</i>&nbsp;
<i>33</i>&nbsp;    public int getUserId(String email) throws EntityNotFoundException {
<b class="nc"><i>34</i>&nbsp;        return userRepository.findByEmail(email).orElseThrow(EntityNotFoundException::userNotFound).getId();</b>
<i>35</i>&nbsp;    }
<i>36</i>&nbsp;
<i>37</i>&nbsp;    public String listUsers() {
<b class="nc"><i>38</i>&nbsp;        return userRepository.findAll()</b>
<b class="nc"><i>39</i>&nbsp;                .stream()</b>
<b class="nc"><i>40</i>&nbsp;                .map(u -&gt; u.getName() + &quot; (&quot; + u.getEmail() + &quot;)&quot;)</b>
<b class="nc"><i>41</i>&nbsp;                .collect(Collectors.joining(&quot;\n&quot;));</b>
<i>42</i>&nbsp;    }
<i>43</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
